context("tapply")

test_that("index and group must be same length", {
  expect_error(tapply(1, 1:2), "same length")
  expect_error(tapply(numeric(0), 1), "same length")

  # No recycling
  expect_error(tapply(1:10, 1:2), "same length")
  expect_error(tapply(1:2, 1:10), "same length")
})

test_that("zero length inputs give zero length outputs", {
  expect_equal(length(tapply(numeric(), numeric())), 0)
  expect_equal(length(tapply(character(), numeric())), 0)
  expect_equal(length(tapply(logical(), numeric())), 0)

  # expect_is(tapply(numeric(), numeric()), "numeric")
  # expect_is(tapply(character(), numeric()), "character")
  # expect_is(tapply(logical(), numeric()), "logical")
})

test_that("if one group per input, input == output", {
  x <- runif(100)
  y <- tapply(x, seq_along(x), "sum")
  
  # expect_equivalent(x, y)
  expect_equivalent(x, as.vector(y))
})